// comanda pe care o primesc de la bluetooth
char comanda = '0';
// Tipul comenzii:
// 1 - fata
// 0 - spate
// L - stanga
// R - dreapta

// pinii de care se leaga cele 4 motoare
int In1 = 7;
int In2 = 8;
int In3 = 12;
int In4 = 13;

// pini de control ai motoarelor
// se leaga ENA de pinul 5 de pe arduino
// se leaga EBB de pinul 11 de pe arduino
int ENA = 5;
int ENB = 11;

// lumini fata
int FataStanga = 4;
int FataDreapta = 6;

// lumini spata
int SpateStanga = 9;
int SpateCentru1 = 10;
int SpateCentru2 = 2;
int SpateDreapta = 3;

// viteza motoare
int SPEED = 220;

// viteza virare stanga - dreapta
int vitezaVirare = 180;

// durata semnalizare lumini spate
int delayLumini = 200;

// pentru a stii cand s-a dat semnal stanga / dreapta
int pulseazaStanga = 0;
int pulseazaDreapta = 0;
int pulseazaMarsarier = 0;

void setup() {
  // pentru modulul Bluetooth
  Serial.begin(9600);

  // pentru led
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);

  pinMode(FataStanga, OUTPUT);
  pinMode(FataDreapta, OUTPUT);
  pinMode(SpateStanga, OUTPUT);
  pinMode(SpateCentru1, OUTPUT);
  
  // setare pini
  pinMode(In1, OUTPUT);
  pinMode(In2, OUTPUT);
  pinMode(In3, OUTPUT);
  pinMode(In4, OUTPUT);
  pinMode(ENA, OUTPUT);
  pinMode(ENB, OUTPUT);

  // daca pun enable aici, merg toate motoarele
  analogWrite(ENA, SPEED);
  analogWrite(ENB, SPEED);
}

void loop() {
  // in caz ca se primeste
  // o comanda Bluetooth
  if (Serial.available() > 0) {
    comanda = Serial.read();

    // pentru orice comanda
    // se primesc luminile fata
    digitalWrite(FataStanga, HIGH);
    digitalWrite(FataDreapta, HIGH);

    // daca se merge inainte
    if (comanda == '1') {
      // daca se semnalizeaza stanga - dreapta
      // se opresc semnalele
      pulseazaStanga = 0;
      pulseazaDreapta = 0;
      pulseazaMarsarier = 0;

      // masina merge inainte
      digitalWrite(In1, HIGH);
      digitalWrite(In2, LOW);
      digitalWrite(In3, HIGH);
      digitalWrite(In4, LOW);
    } else if (comanda == '0') {
      // daca se semnalizeaza stanga - dreapta
      // se opresc semnalele
      pulseazaStanga = 0;
      pulseazaDreapta = 0;
      pulseazaMarsarier = 1;

      // masina merge inapoi
      digitalWrite(In1, LOW);
      digitalWrite(In2, HIGH);
      digitalWrite(In3, LOW);
      digitalWrite(In4, HIGH);
    } else if (comanda == 'L') {
       // cand se vireaza stanga / dreapta viteza scade
      analogWrite(ENA, vitezaVirare);
      analogWrite(ENB, vitezaVirare);

      // setare semnal stanga
      pulseazaStanga = 0;
      pulseazaDreapta = 1;
      pulseazaMarsarier = 0;

      // mers stanga
      digitalWrite(In1, LOW);
      digitalWrite(In2, LOW);
      digitalWrite(In3, HIGH);
      digitalWrite(In4, LOW);
   } else if (comanda = 'R') {
      // cand se vireaza stanga / dreapta viteza scade
      analogWrite(ENA, vitezaVirare);
      analogWrite(ENB, vitezaVirare);

      // setare semnal dreapta
      pulseazaStanga = 1;
      pulseazaDreapta = 0;
      pulseazaMarsarier = 0;

      // mers dreapta
      digitalWrite(In1, HIGH);
      digitalWrite(In2, LOW);
      digitalWrite(In3, LOW);
      digitalWrite(In4, LOW);
    } else {
      // orice alt semnal opreste masina
      digitalWrite(In1, LOW);
      digitalWrite(In2, LOW);
      digitalWrite(In3, LOW);
      digitalWrite(In4, LOW);
    }
  }

  // daca se face stanga
  if (pulseazaStanga == 1) {
      // lumini stanga spate - semnalizeaza
      digitalWrite(SpateStanga, HIGH);
      digitalWrite(SpateCentru1, HIGH);
      delay(delayLumini);
      digitalWrite(SpateStanga, LOW);
      digitalWrite(SpateCentru1, LOW);
      delay(delayLumini);
  }

  // daca se face dreapta
  if (pulseazaDreapta == 1) {
      // lumini dreapta spate - semnalizeaza
      digitalWrite(SpateCentru2, HIGH);
      digitalWrite(SpateDreapta, HIGH);
      delay(delayLumini);
      digitalWrite(SpateCentru2, LOW);
      digitalWrite(SpateDreapta, LOW);
      delay(delayLumini);
  }

  if (pulseazaMarsarier == 1) {
      // lumini stanga spate - semnalizeaza
      digitalWrite(SpateStanga, HIGH);
      digitalWrite(SpateCentru1, HIGH);
      // lumini dreapta spate - semnalizeaza
      digitalWrite(SpateCentru2, HIGH);
      digitalWrite(SpateDreapta, HIGH);
      
      delay(delayLumini);
      digitalWrite(SpateStanga, LOW);
      digitalWrite(SpateCentru1, LOW);
      digitalWrite(SpateCentru2, LOW);
      digitalWrite(SpateDreapta, LOW);
      delay(delayLumini);
  }
}
